#!/usr/bin/env python
import sys
import threading

import socketio

sio = socketio.Client()

my_cards = []


@sio.event
def leave_game():
    print('We were asked to leave')
    sys.exit(0)


@sio.event
def new_lap(took):
    print('New lap beginning')


@sio.event
def table_cards(cards, dealer):
    print('Table cards, for the one card lap')
    print(cards)


@sio.event
def your_cards(cards, dealer):
    global my_cards
    print('My cards')
    print(cards)
    my_cards = cards


@sio.event
def please_bet():
    bet = int(input('Please, bet: '))
    sio.emit('bet', bet)


@sio.event
def bet(player, bet):
    print('New bet: ', bet, player)


@sio.event
def please_move():
    print('Please move, these are your current cards:')
    print(my_cards)
    idx = int(input('Choose one: '))
    card = my_cards.pop(idx)
    sio.emit('move', (card[0], card[1]))


@sio.event
def move(player, card, taking):
    print('New move: ', card, player, taking)


@sio.event
def hand_ended(dead_players, lives):
    print('Hand ended.')
    print('Someone dead? ', dead_players)
    print('Lives', lives)


@sio.event
def game_ended(winner):
    print('Game ended. ', winner)


@sio.event
def players(pl):
    print('New players dict', pl)


@sio.event
def joined(game_id, owner):
    print('Joined', game_id)


@sio.event
def exception(message):
    print('The server is complaining:', message)


def setup_thread():
    name = input('Please enter your name: ')

    op = input('Press c to create, j to join: ')
    if op == 'c':
        sio.emit('create', name)
        input('Press enter to start the game')
        sio.emit('start')
    elif op == 'j':
        gid = input('Please enter the game id: ')
        sio.emit('join', (gid, name))
    else:
        print('The instructions were clear.')
        sio.disconnect()
        sys.exit(1)


if __name__ == '__main__':
    th = threading.Thread(target=setup_thread)
    th.start()
    sio.connect('http://localhost:5000')
